<?php
/*
 * Author: Renaun Erickson http://renaun.com (2007) 
 */
 
include_once( "db_config.php" );
include_once( "lib/nusoap.php" );

// A made up namespace
$namespace = "http://localhost/flexphp/contacts/wsdl";

$server = new soap_server();
$server->debug_flag = false;
$server->configureWSDL( "ContactsWSDL", $namespace );
$server->wsdl->schemaTargetNamespace = $namespace;

// Contact Data Type
$server->wsdl->addComplexType(
  'Contact',
  'complexType',
  'struct',
  'all',
  '',
  array(
    'id' => array('name' => 'id',
         'type' => 'xsd:int'),
    'First' => array('name' => 'First', 
         'type' => 'xsd:string'),
    'Middle' => array('name' => 'Middle', 
         'type' => 'xsd:string'),
    'Last' => array('name' => 'Last', 
         'type' => 'xsd:string'),
    'Cell' => array('name' => 'Cell', 
         'type' => 'xsd:string'),
    'Home' => array('name' => 'Home', 
         'type' => 'xsd:string'),
    'Street' => array('name' => 'Street', 
         'type' => 'xsd:string'),
    'City' => array('name' => 'City', 
         'type' => 'xsd:string'),
    'State' => array('name' => 'State', 
         'type' => 'xsd:string'),
    'Zip' => array('name' => 'Zip', 
         'type' => 'xsd:string'),
  )
);

// Array of Contacts 
$server->wsdl->addComplexType(
  'Contacts',
  'complexType', 
  'array', 
  '', 
  'SOAP-ENC:Array', 
  array(),
  array(
    array('ref' => 'SOAP-ENC:arrayType', 
         'wsdl:arrayType' => 'tns:Contact[]')
  ),
  'tns:Contact'
);

$server->register('GetContacts',                    // method name
  array(),          // input parameters
  array('return' => 'tns:Contacts'),    // output parameters
  $namespace,                         // namespace
  $namespace . '#GetContacts',                   // soapaction
  'rpc',                                    // style
  'encoded',                                // use
  'Get Contacts'        // documentation
);

$server->register('MaintainContact',                    // method name
  array('inputStructArray'=>'tns:Contact'),          // input parameters
  array('return' => 'xsd:string'),    // output parameters
  $namespace,                         // namespace
  $namespace . '#MaintainContact',                   // soapaction
  'rpc',                                    // style
  'encoded',                                // use
  'MaintainContact'        // documentation
);

function GetContacts() 
{
	// Query for all the contacts
	$query = "SELECT * FROM contacts";
	
	$result = mysql_query( $query );
	
	// Contacts Array
	$contacts = array();
	
	// Loop over results and create XML Contact nodes
	if( $result ) {
		while( $contact = mysql_fetch_assoc( $result ) ) {
			$contacts[] = $contact;
		}
	}
	
	// Return Contacts
	return $contacts;	
}

function MaintainContact( $contact ) 
{
	$status = "Contact Action Failed!";	
	$isNew = false;
	
	// Incoming value
	if( isset( $contact[ "id" ] ) ) {
		$id		= mysql_real_escape_string( $contact[ "id" ] );
	} else {
		$isNew = true;
	}
	// Escapse special characters
	$First 	= mysql_real_escape_string( $contact[ "First" ] );
	$Middle	= mysql_real_escape_string( $contact[ "Middle" ] );
	$Last	= mysql_real_escape_string( $contact[ "Last" ] );
	$Cell	= mysql_real_escape_string( $contact[ "Cell" ] );
	$Home	= mysql_real_escape_string( $contact[ "Home" ] );
	$Street	= mysql_real_escape_string( $contact[ "Street" ] );
	$City	= mysql_real_escape_string( $contact[ "City" ] );
	$State	= mysql_real_escape_string( $contact[ "State" ] );
	$Zip	= mysql_real_escape_string( $contact[ "Zip" ] );
	
	// Query for all the contacts
	if( $isNew ) {
		$query = "INSERT INTO contacts SET ";
		$query .= "First='$First', Middle='$Middle', ";
		$query .= "Last='$Last', Cell='$Cell', ";
		$query .= "Home='$Home', Street='$Street', ";
		$query .= "City='$City', State='$State', ";
		$query .= "Zip='$Zip';";
	} else {
		$query = "UPDATE contacts SET ";
		$query .= "First='$First', Middle='$Middle', ";
		$query .= "Last='$Last', Cell='$Cell', ";
		$query .= "Home='$Home', Street='$Street', ";
		$query .= "City='$City', State='$State', ";
		$query .= "Zip='$Zip' WHERE ";	
		$query .= "id='$id';";
	}
	
	$result = @mysql_query( $query );
	
	if( $result ) {
//		foreach( $contact as $key => $value )
//			$status .= "Contact Action Completed Successfully!" . $key . " - " . $value;
		$status = "Contact Action Completed Successfully!";
	}
	
	return $status;	
}


$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service( $HTTP_RAW_POST_DATA );

?>